///////////////////////////
// glitchme.exe
// Made for ludumdare 27
// libs: allegro 4.2.2, allegrogl 0.4.3
// remove PlaySound to compile under Linux
// by Sos
// http://sos.gd
///////////////////////////

#include <stdio.h>
#include <allegro.h>
#include <winalleg.h>
#include <alleggl.h>
#include <windows.h>
#include <math.h>
#include "music.h"
#include "win.h"


#define TURN_SPEED .1 // trunign speed
#define MOVE_SPEED 6.5 // default move speed
#define WORLD_SIZE 7000.0 // length of track
#define WORLD_WIDTH 100.0 // width of track
#define GRID_SIZE 25.0 // grid unit size

#define SLICES 16 // tunnel mesh slices
#define ROWS 500 // tunnel mesh rows
#define NUM (ROWS*SLICES*4) // tunnel mesh size

#define FRAND ((rand()%1024)/1024.0f) // 0..1 rand
#define SFRAND (((rand()%2048)/1024.0f)-1.0f) // -1..1 rand
#define DEG(n)   ((n) * 180.0 / M_PI) // rad2deg
#define LERP(a,b,c)  (((b) - (a)) * (c) + (a)) // lerp

// states
#define WALK 1
#define IDLE 2
#define STOP 3

#define HEIGHT 10.0 // player height
#define HEIGHTF 40.0 // ??
#define FPS 60 // frames per second
#define SECONDS 10 // seconds till crash
#define DURATION (FPS*SECONDS) // frames till crash
#define POWERUPS 32 // powerups number

/////////////////
static int first; // static shit is continuous, this is the first variable
/////////////////

// these are contiguous so that stuff gets fucked up in order its written here

static float tree[ROWS][SLICES][4][3]; // tunnel
static float powerups[POWERUPS][3]; // powerup positions
static float playerx,playery,playerz,lookx,looky,lookz; // player pos
static float move_speed=MOVE_SPEED; // move speed
static float lookf,blur=.1,fov=1; // look direction, motion blur amount, field of vision
static int frames,state,recolour,gameover,intro; // unused
static float dummy[256]; // dummy slowdown
volatile int tim; // time update
static int timeleft=600; // countdown for clock
static int win=0; // black or white
static char temp[6560]; // slowdown

/////////////////
static int last; // this is the last variable
/////////////////

float* glitchspot; // this is the address of glitching, once this gets fucked up, shit gets real


// glitching
void glitch()
{
	// treating numbers as floats makes sure ints gets fucked up big time
	(*glitchspot++)+=(rand()%64)-32;
}

// clock drawing helper draws a radius segment
void radius(float a,float d1,float d2)
{
	float p[4],ry=1,rx=3.0f/4.0f;
	p[0] = cos(a)*d1*rx;
	p[1] = sin(a)*d1*ry;
	p[2] = cos(a)*d2*rx;
	p[3] = sin(a)*d2*ry;
	glVertex2f(p[0],p[1]);
	glVertex2f(p[2],p[3]);
}

// draws powerups and goal powerup
void draw_powerups()
{
	int c,i;
	float x,y,z;
	glLineWidth(5.0f);
	glDisable(GL_DEPTH_TEST);
	glLineWidth(10.0f);
	glBegin(GL_LINES);
	c=0;

	// draws goal powerup white/black
	for(i=0;i<200;i++)
	{
		glColor4f(1,1,1,1);
		glVertex3f(powerups[c][0],powerups[c][1],powerups[c][2]);
		glColor4f(1,1,1,0);
		x=powerups[c][0]+(SFRAND*SFRAND)*400;
		y=powerups[c][1]+(SFRAND*SFRAND)*400;
		z=powerups[c][2]+(SFRAND*SFRAND)*400;
		if (!(rand()%320))
		{
			x+=FRAND*2000-1000;
			y+=FRAND*2000-1000;
			z+=FRAND*2000-1000;
		}
		glVertex3f(x,y,z);
	}
	for(i=0;i<50;i++)
	{
		glColor4f(0,0,0,1);
		glVertex3f(powerups[c][0],powerups[c][1],powerups[c][2]);
		glColor4f(1,1,1,0);
		x=powerups[c][0]+(SFRAND*SFRAND)*40;
		y=powerups[c][1]+(SFRAND*SFRAND)*40;
		z=powerups[c][2]+(SFRAND*SFRAND)*40;
		if (!(rand()%320))
		{
			x+=FRAND*200-100;
			y+=FRAND*200-100;
			z+=FRAND*200-100;
		}
		glVertex3f(x,y,z);
	}
	glEnd();
	glBegin(GL_LINES);
	// draws speed powerups red/black
	for (c=1;c<POWERUPS;c++)
	{
		for(i=0;i<100;i++)
		{
			glColor4f(1,0,0,1);
			glVertex3f(powerups[c][0],powerups[c][1],powerups[c][2]);
			glColor4f(0,0,0,0);
			x=powerups[c][0]+(SFRAND*SFRAND)*20;
			y=powerups[c][1]+(SFRAND*SFRAND)*20;
			z=powerups[c][2]+(SFRAND*SFRAND)*20;
			if (!(rand()%320))
			{
				x+=FRAND*200-100;
				y+=FRAND*200-100;
				z+=FRAND*200-100;
			}
			glVertex3f(x,y,z);
		}
	}
	glEnd();

	glEnable(GL_DEPTH_TEST);
}


// draws clock
void draw_clock()
{
	float p[4],a,d1,d2,r;
	int c;
	static int show=0;
	// fade thingie
	if (!(timeleft%FPS)) show=20;
	if (show--<0) return;
	r = show/10.0f;
	r=r*r;
	glColor4f(r,0,0,r);
	glLineWidth(4.0);
	// draws clock
	glBegin(GL_LINES);
	for(c=0;c<60;c++)
	{
		radius(2*M_PI*c/60,(!(c%5)) ? .8 : .9,1);
	}
	glEnd();
	a = M_PI*2*(1.0f*timeleft)/(FPS*60)+M_PI/2;
	// draws current time
	for(c=0;c<10;c++)
	{
		glLineWidth((10-c)*4);
		glBegin(GL_LINES);
		radius(a,0,c/10.0f);
		glEnd();
	}


}

// draws ground and tunnel
void draw_tree()
{
	int c,b,n;
	float x,y,sx,sy;

	// draws ground checkerboard

	c=0;
	srand(563245);

	glBegin(GL_QUADS);
	for (x=0;x<WORLD_SIZE;x+=GRID_SIZE)
	{
		for (y=-WORLD_WIDTH;y<WORLD_WIDTH;y+=GRID_SIZE)
		{
			c++;
			if (c&1)
			{
				if (win) glColor3f(1,1,1); else glColor3f(0,0,0);
			} else continue;//glColor3f(.3,.6,.4);
			if (x<rand()%2000) continue;
			glVertex3f(x,0.0,y);
			glVertex3f(x,0.0,y+GRID_SIZE);
			glVertex3f(x+GRID_SIZE,0.0,y+GRID_SIZE);
			glVertex3f(x+GRID_SIZE,0.0,y);

		}
		c++;
	}
	glEnd();

	srand(clock());
	glDisable(GL_TEXTURE_2D);
	glLineWidth(2.71);
	glDisable(GL_DEPTH_TEST);
	// draws tunnel
	if (win) glColor4f(1,1,1,1); else glColor4f(0,0,0,1);
	glDrawArrays(GL_LINES, 0,NUM);
	glEnable(GL_DEPTH_TEST);
}


// generates shit
void generate_stuff()
{
	int c,x,y;
	float f;

	// generates powerup positions
	for (c=0;c<POWERUPS;c++)
	{
		powerups[c][2]=FRAND*WORLD_WIDTH*2-WORLD_WIDTH;
		powerups[c][0]=FRAND*WORLD_SIZE;
		powerups[c][1]=10.0f;
	}

	// goal powerup is at the end of tunnel
	powerups[0][2]=0;
	powerups[0][0]=WORLD_SIZE-800.0f;
	powerups[0][1]=10.0f;

	// generates tunnel mesh
	for(x=0;x<ROWS;x++)
	{
		for(y=0;y<SLICES;y++)
		{
			float radius=WORLD_WIDTH;
			float angle = y*M_PI/SLICES;
			float pos = x*WORLD_SIZE/ROWS;
			float anglediff = M_PI/SLICES;
			float posdiff = WORLD_SIZE/ROWS;
			if (x<rand()%50) continue;
			if (x>ROWS-32)
			{
				float left=(ROWS-x)/32.0f;
				radius = radius*sin(left*M_PI/2);
			}
			tree[x][y][0][2] = cos(angle)*radius;
			tree[x][y][0][1] = sin(angle)*radius;
			tree[x][y][0][0] = pos;

			tree[x][y][1][2] = cos(angle+anglediff)*radius;
			tree[x][y][1][1] = sin(angle+anglediff)*radius;
			tree[x][y][1][0] = pos+posdiff;

			tree[x][y][2][2] = cos(angle+anglediff)*radius;
			tree[x][y][2][1] = sin(angle+anglediff)*radius;
			tree[x][y][2][0] = pos;

			tree[x][y][3][2] = cos(angle)*radius;
			tree[x][y][3][1] = sin(angle)*radius;
			tree[x][y][3][0] = pos+posdiff;
		}
	}


}

// update proc
void timer_proc(void)
{
	float r,g,b;
	int c,glitchspeed;
	float x,y,z,d;
	move_speed = LERP(move_speed,MOVE_SPEED,.01);
	timeleft--;

	// glitchspeed makes sure it crahses after 10s
	glitchspeed = ((&last)-(&first))/(DURATION);
	// glitches glitchspeed dwords
	for (c=0;c<glitchspeed;c++) glitch();

	//tunring
	if (key[KEY_LEFT]) {looky -= TURN_SPEED;}
	if (key[KEY_RIGHT]) {looky += TURN_SPEED;}


	// walking
	if (key[KEY_UP])
	{
		playerx += cos(looky)*move_speed;
		playerz += sin(looky)*move_speed;
		state=WALK;
	}

	if (key[KEY_DOWN])
	{
		playerx -= cos(looky)*move_speed;
		playerz -= sin(looky)*move_speed;
		state=WALK;
	}



	if (!key[KEY_UP] && !key[KEY_DOWN] && state!=IDLE)
		state=IDLE;


	// head bobbing

	if (state==IDLE)
	{
		lookf+=.1;
		playery=((HEIGHT/10.0)*sin(lookf))+HEIGHT;
	}

	if (state==WALK)
	{
		lookf+=0.5;
		playery=HEIGHT+((HEIGHT/13.0)*ABS(sin(lookf)));
	}


	if (key[KEY_SPACE])
	{
		if (lookx<M_PI/4) lookx+=.1;
	} else {
		if (lookx>0.0) lookx-=.2;
	}

	// player position clipping
	if(playerx>(WORLD_SIZE-500.0)) playerx=(WORLD_SIZE-500.0);
	if(playerz>(WORLD_WIDTH-5.0)) playerz=(WORLD_WIDTH-5.0);
	if(playerx<5.0) playerx=5.0;
	if(playerz<-WORLD_WIDTH+5.0) playerz=-WORLD_WIDTH+5.0;

	// checks powerup pickup
	for(c=0;c<POWERUPS;c++)
	{
		x = powerups[c][0]-playerx;
		y = powerups[c][1]-playery;
		z = powerups[c][2]-playerz;
		d=sqrt(x*x+y*y+z*z);
		if (d<(c ? 25 : 150)) // if picked up
		{
			win=win^1; // change black/white
			// move away
			powerups[c][0]+=FRAND*10000000;
			powerups[c][1]+=FRAND*10000000;
			powerups[c][2]+=FRAND*10000000;
			move_speed+=MOVE_SPEED*.5; // accelerate
			blur=0; // blur
			fov=.2; // fov
			if (!c)
			{
				PlaySound(youwin_wav,0,SND_ASYNC|SND_MEMORY); // if goal, play you win
			}
		}
	}

}
// drawing proc
void draw (void)
{
	int c;
	float r,g,b,mx,my;

	// sets up camera
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glPushMatrix();
	fov = LERP(fov,1,.02);
	glFrustum (-(4.0/3.0), 4.0/3.0, -1.0, 1.0, fov, 8000.0);
	glMatrixMode (GL_MODELVIEW);
	glClear(GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glPushMatrix();

	glRotatef (DEG(lookx), 1, 0, 0);
	glRotatef (DEG(looky)+90.0, 0, 1, 0);
	glRotatef (DEG(lookz), 0, 0, 1);
	glTranslatef (-playerx, -playery, -playerz);


	glMatrixMode (GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glMatrixMode (GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	// draws alpha'd quad for blur
	blur=LERP(blur,.3,.2);
	glDepthMask(GL_FALSE);
	if (win) glColor4f(0,0,0,blur); else glColor4f(1,1,1,blur);
	glBegin(GL_QUADS);
	glVertex2f(-1.0,1.0);
	glVertex2f(1.0,1.0);
	glVertex2f(1.0,-1.0);
	glVertex2f(-1.0,-1.0);
	glEnd();
	glDepthMask(GL_TRUE);


	glMatrixMode (GL_PROJECTION);
	glPopMatrix();

	glMatrixMode (GL_MODELVIEW);
	glPopMatrix();

	// draws level
	draw_tree();
	// draws powerups
	draw_powerups();

	glMatrixMode (GL_PROJECTION);
	glPopMatrix();
	glMatrixMode (GL_MODELVIEW);
	glPopMatrix();
	// draws clock
	draw_clock();
	glPointSize(3.0);
	glDisable(GL_TEXTURE_2D);


	glColor3f(1.0,1.0,1.0);
	mx=(mouse_x-320)/320.0;
	my=-(mouse_y-240)/240.0;


	allegro_gl_flip();

}

void timer(void)
{
	tim++;
}
END_OF_FUNCTION(timer);

int main ()
{
	int c;
	first=2.0;
	allegro_init();

	install_allegro_gl();
	allegro_gl_clear_settings();
	allegro_gl_set (AGL_COLOR_DEPTH, 32);
	allegro_gl_set (AGL_Z_DEPTH, 24);
	allegro_gl_set (AGL_WINDOWED, TRUE);
	allegro_gl_set (AGL_DOUBLEBUFFER, 1);
	allegro_gl_set (AGL_SUGGEST, AGL_COLOR_DEPTH | AGL_Z_DEPTH
		| AGL_DOUBLEBUFFER | AGL_WINDOWED);

	if (set_gfx_mode(GFX_OPENGL, 800, 600, 0, 0) < 0) {
		allegro_message ("Error setting OpenGL graphics mode:\n%s\n"
			"Allegro GL error : %s\n",
			allegro_error, allegro_gl_error);
		return -1;
	}


	install_keyboard();
	install_timer();
	install_mouse();

	LOCK_FUNCTION(timer);
	LOCK_VARIABLE(tim);
	install_int_ex (timer, BPS_TO_TIMER(FPS));

	srand(time(NULL));

	generate_stuff();


	glEnable( GL_LINE_SMOOTH );
	glEnable( GL_POLYGON_SMOOTH );
	glHint( GL_LINE_SMOOTH_HINT, GL_NICEST );
	glHint( GL_POLYGON_SMOOTH_HINT, GL_NICEST );
	glShadeModel (GL_SMOOTH);
	glEnable (GL_DEPTH_TEST);
	glCullFace (GL_FRONT_AND_BACK);
	glDisable (GL_CULL_FACE);
	glLineWidth(5);
	glEnable(GL_TEXTURE_2D);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);


	glEnableClientState(GL_VERTEX_ARRAY);
	glVertexPointer(3, GL_FLOAT, 0, tree);

	playerx=WORLD_WIDTH/2;playerz=0;looky=0;

	//printf("First: %08X, Last: %08X, Diff: %08X",&first,&last,(&last)-(&first));
	glitchspot=&first;

	PlaySound(_0s_wav,0,SND_ASYNC|SND_MEMORY);
	do {
		while (tim>0)
		{
			draw();
			timer_proc();
			tim--;
		}

	} while (!key[KEY_ESC]);


	set_gfx_mode (GFX_TEXT, 0, 0, 0, 0);
	return 0;
}
END_OF_MAIN()

